/*
  File autogenerated by gengetopt version 2.17
  generated with the following command:
  gengetopt --no-handle-version --conf-parser --file-name=gui.cmdline --func-name gui_cmdline_parser --arg-struct-name=gui_args_info --set-package=para_gui --set-version=0.2.15 

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "getopt.h"

#include "gui.cmdline.h"

const char *gui_args_info_purpose = "";

const char *gui_args_info_usage = "Usage: para_gui [OPTIONS]...";

const char *gui_args_info_help[] = {
  "  -h, --help                  Print help and exit",
  "  -V, --version               Print version and exit",
  "\ngeneral options:",
  "  -a, --auto_decode           auto-decode audio stream  (default=on)",
  "  -c, --config_file=filename  (default='~/.paraslash/gui.conf')",
  "  -l, --loglevel=level        set loglevel (0-6)  (default=`4')",
  "  -t, --timeout=milliseconds  set timeout  (default=`30')",
  "  -s, --stat_cmd=command      command to read server and audiod status data \n                                from  (default=`para_audioc stat')",
  "\nmapping keys to commands:",
  "  -k, --key_map=k:m:c         Map key k to command c using mode m. Mode may be \n                                d, x or p for display, external and paraslash \n                                commands, respectively. Of course, this option \n                                may be given multiple times, one for each key \n                                mapping.",
    0
};

static
void clear_given (struct gui_args_info *args_info);
static
void clear_args (struct gui_args_info *args_info);

static int
gui_cmdline_parser_internal (int argc, char * const *argv, struct gui_args_info *args_info, int override, int initialize, int check_required, const char *additional_error);

static int
gui_cmdline_parser_required2 (struct gui_args_info *args_info, const char *prog_name, const char *additional_error);
struct line_list
{
  char * string_arg;
  struct line_list * next;
};

static struct line_list *cmd_line_list = 0;
static struct line_list *cmd_line_list_tmp = 0;

static void
free_cmd_list(void)
{
  /* free the list of a previous call */
  if (cmd_line_list)
    {
      while (cmd_line_list) {
        cmd_line_list_tmp = cmd_line_list;
        cmd_line_list = cmd_line_list->next;
        free (cmd_line_list_tmp->string_arg);
        free (cmd_line_list_tmp);
      }
    }
}


struct string_list
{
  char * arg;
  char *orig;
  struct string_list * next;
};

static char *
gengetopt_strdup (const char *s);

static
void clear_given (struct gui_args_info *args_info)
{
  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->auto_decode_given = 0 ;
  args_info->config_file_given = 0 ;
  args_info->loglevel_given = 0 ;
  args_info->timeout_given = 0 ;
  args_info->stat_cmd_given = 0 ;
  args_info->key_map_given = 0 ;
}

static
void clear_args (struct gui_args_info *args_info)
{
  args_info->auto_decode_flag = 1;
  args_info->config_file_arg = NULL;
  args_info->config_file_orig = NULL;
  args_info->loglevel_arg = 4;
  args_info->loglevel_orig = NULL;
  args_info->timeout_arg = 30;
  args_info->timeout_orig = NULL;
  args_info->stat_cmd_arg = gengetopt_strdup ("para_audioc stat");
  args_info->stat_cmd_orig = NULL;
  args_info->key_map_arg = NULL;
  args_info->key_map_orig = NULL;
  
}

static
void init_args_info(struct gui_args_info *args_info)
{
  args_info->help_help = gui_args_info_help[0] ;
  args_info->version_help = gui_args_info_help[1] ;
  args_info->auto_decode_help = gui_args_info_help[3] ;
  args_info->config_file_help = gui_args_info_help[4] ;
  args_info->loglevel_help = gui_args_info_help[5] ;
  args_info->timeout_help = gui_args_info_help[6] ;
  args_info->stat_cmd_help = gui_args_info_help[7] ;
  args_info->key_map_help = gui_args_info_help[9] ;
  args_info->key_map_min = -1;
  args_info->key_map_max = -1;
  
}

void
gui_cmdline_parser_print_version (void)
{
  printf ("%s %s\n", GUI_CMDLINE_PARSER_PACKAGE, GUI_CMDLINE_PARSER_VERSION);
}

void
gui_cmdline_parser_print_help (void)
{
  int i = 0;
  gui_cmdline_parser_print_version ();

  if (strlen(gui_args_info_purpose) > 0)
    printf("\n%s\n", gui_args_info_purpose);

  printf("\n%s\n\n", gui_args_info_usage);
  while (gui_args_info_help[i])
    printf("%s\n", gui_args_info_help[i++]);
}

void
gui_cmdline_parser_init (struct gui_args_info *args_info)
{
  clear_given (args_info);
  clear_args (args_info);
  init_args_info (args_info);
}

static void
gui_cmdline_parser_release (struct gui_args_info *args_info)
{
  
  unsigned int i;
  if (args_info->config_file_arg)
    {
      free (args_info->config_file_arg); /* free previous argument */
      args_info->config_file_arg = 0;
    }
  if (args_info->config_file_orig)
    {
      free (args_info->config_file_orig); /* free previous argument */
      args_info->config_file_orig = 0;
    }
  if (args_info->loglevel_orig)
    {
      free (args_info->loglevel_orig); /* free previous argument */
      args_info->loglevel_orig = 0;
    }
  if (args_info->timeout_orig)
    {
      free (args_info->timeout_orig); /* free previous argument */
      args_info->timeout_orig = 0;
    }
  if (args_info->stat_cmd_arg)
    {
      free (args_info->stat_cmd_arg); /* free previous argument */
      args_info->stat_cmd_arg = 0;
    }
  if (args_info->stat_cmd_orig)
    {
      free (args_info->stat_cmd_orig); /* free previous argument */
      args_info->stat_cmd_orig = 0;
    }
  if (args_info->key_map_arg)
    {
      for (i = 0; i < args_info->key_map_given; ++i)
        {
          if (args_info->key_map_arg [i])
            {
              free (args_info->key_map_arg [i]); /* free previous argument */
              args_info->key_map_arg [i] = 0;
            }
          if (args_info->key_map_orig [i])
            {
              free (args_info->key_map_orig [i]); /* free previous argument */
              args_info->key_map_orig [i] = 0;
            }
        }
      if (args_info->key_map_arg [0])
        free (args_info->key_map_arg [0]); /* free default string */
      free (args_info->key_map_arg); /* free previous argument */
      args_info->key_map_arg = 0;
      free (args_info->key_map_orig); /* free previous argument */
      args_info->key_map_orig = 0;
    }
  
  clear_given (args_info);
}

int
gui_cmdline_parser_file_save(const char *filename, struct gui_args_info *args_info)
{
  FILE *outfile;
  int i = 0;

  outfile = fopen(filename, "w");

  if (!outfile)
    {
      fprintf (stderr, "%s: cannot open file for writing: %s\n", GUI_CMDLINE_PARSER_PACKAGE, filename);
      return EXIT_FAILURE;
    }

  if (args_info->help_given) {
    fprintf(outfile, "%s\n", "help");
  }
  if (args_info->version_given) {
    fprintf(outfile, "%s\n", "version");
  }
  if (args_info->auto_decode_given) {
    fprintf(outfile, "%s\n", "auto_decode");
  }
  if (args_info->config_file_given) {
    if (args_info->config_file_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "config_file", args_info->config_file_orig);
    } else {
      fprintf(outfile, "%s\n", "config_file");
    }
  }
  if (args_info->loglevel_given) {
    if (args_info->loglevel_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "loglevel", args_info->loglevel_orig);
    } else {
      fprintf(outfile, "%s\n", "loglevel");
    }
  }
  if (args_info->timeout_given) {
    if (args_info->timeout_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "timeout", args_info->timeout_orig);
    } else {
      fprintf(outfile, "%s\n", "timeout");
    }
  }
  if (args_info->stat_cmd_given) {
    if (args_info->stat_cmd_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "stat_cmd", args_info->stat_cmd_orig);
    } else {
      fprintf(outfile, "%s\n", "stat_cmd");
    }
  }
  if (args_info->key_map_orig)
    {
      for (i = 0; i < args_info->key_map_given; ++i)
        {
          if (args_info->key_map_orig [i])
            {
              fprintf(outfile, "%s=\"%s\"\n", "key_map", args_info->key_map_orig [i]);
            }
        }
    }
  
  fclose (outfile);

  i = EXIT_SUCCESS;
  return i;
}

void
gui_cmdline_parser_free (struct gui_args_info *args_info)
{
  gui_cmdline_parser_release (args_info);
}


/* gengetopt_strdup() */
/* strdup.c replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = NULL;
  if (!s)
    return result;

  result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

static char *
get_multiple_arg_token(const char *arg)
{
  char *tok, *ret;
  size_t len, num_of_escape;
  int i, j;

  if (!arg)
    return NULL;

  tok = strchr (arg, ',');
  num_of_escape = 0;

  /* make sure it is not escaped */
  while (tok)
    {
      if (*(tok-1) == '\\')
        {
          /* find the next one */
          tok = strchr (tok+1, ',');
          ++num_of_escape;
        }
      else
        break;
    }

  if (tok)
    len = (size_t)(tok - arg + 1);
  else
    len = strlen (arg) + 1;

  len -= num_of_escape;

  ret = (char *) malloc (len);

  i = 0;
  j = 0;
  while (arg[i] && (j < len-1))
    {
      if (arg[i] == '\\')
        ++i;

      ret[j++] = arg[i++];
    }

  ret[len-1] = '\0';

  return ret;
}

static char *
get_multiple_arg_token_next(const char *arg)
{
  char *tok;

  if (!arg)
    return NULL;

  tok = strchr (arg, ',');

  /* make sure it is not escaped */
  while (tok)
    {
      if (*(tok-1) == '\\')
        {
          /* find the next one */
          tok = strchr (tok+1, ',');
        }
      else
        break;
    }

  if (! tok || strlen(tok) == 1)
    return 0;

  return tok+1;
}

static int
check_multiple_option_occurrences(const char *prog_name, unsigned int option_given, int min, int max, const char *option_desc);

int
check_multiple_option_occurrences(const char *prog_name, unsigned int option_given, int min, int max, const char *option_desc)
{
  int error = 0;

  if (option_given && ! (min < 0 && max < 0))
    {
      if (min >= 0 && max >= 0)
        {
          if (min == max)
            {
              /* specific occurrences */
              if (option_given != min)
                {
                  fprintf (stderr, "%s: %s option occurrences must be %d\n",
                    prog_name, option_desc, min);
                  error = 1;
                }
            }
          else if (option_given < min
              || option_given > max)
            {
              /* range occurrences */
              fprintf (stderr, "%s: %s option occurrences must be between %d and %d\n",
                prog_name, option_desc, min, max);
              error = 1;
            }
        }
      else if (min >= 0)
        {
          /* at least check */
          if (option_given < min)
            {
              fprintf (stderr, "%s: %s option occurrences must be at least %d\n",
                prog_name, option_desc, min);
              error = 1;
            }
        }
      else if (max >= 0)
        {
          /* at most check */
          if (option_given > max)
            {
              fprintf (stderr, "%s: %s option occurrences must be at most %d\n",
                prog_name, option_desc, max);
              error = 1;
            }
        }
    }
    
  return error;
}
int
gui_cmdline_parser (int argc, char * const *argv, struct gui_args_info *args_info)
{
  return gui_cmdline_parser2 (argc, argv, args_info, 0, 1, 1);
}

int
gui_cmdline_parser2 (int argc, char * const *argv, struct gui_args_info *args_info, int override, int initialize, int check_required)
{
  int result;

  result = gui_cmdline_parser_internal (argc, argv, args_info, override, initialize, check_required, NULL);

  if (result == EXIT_FAILURE)
    {
      gui_cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
gui_cmdline_parser_required (struct gui_args_info *args_info, const char *prog_name)
{
  int result = EXIT_SUCCESS;

  if (gui_cmdline_parser_required2(args_info, prog_name, NULL) > 0)
    result = EXIT_FAILURE;

  if (result == EXIT_FAILURE)
    {
      gui_cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
gui_cmdline_parser_required2 (struct gui_args_info *args_info, const char *prog_name, const char *additional_error)
{
  int error = 0;

  /* checks for required options */
  if (check_multiple_option_occurrences(prog_name, args_info->key_map_given, args_info->key_map_min, args_info->key_map_max, "'--key_map' ('-k')"))
     error = 1;
  
  
  /* checks for dependences among options */

  return error;
}

int
gui_cmdline_parser_internal (int argc, char * const *argv, struct gui_args_info *args_info, int override, int initialize, int check_required, const char *additional_error)
{
  int c;	/* Character of the parsed option.  */
  char *multi_token, *multi_next; /* for multiple options */

  int i;        /* Counter */

  struct string_list * key_map_list = NULL,* key_map_new = NULL;
  int error = 0;
  struct gui_args_info local_args_info;

  if (initialize)
    gui_cmdline_parser_init (args_info);

  gui_cmdline_parser_init (&local_args_info);

  optarg = 0;
  optind = 0;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      char *stop_char;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "auto_decode",	0, NULL, 'a' },
        { "config_file",	1, NULL, 'c' },
        { "loglevel",	1, NULL, 'l' },
        { "timeout",	1, NULL, 't' },
        { "stat_cmd",	1, NULL, 's' },
        { "key_map",	1, NULL, 'k' },
        { NULL,	0, NULL, 0 }
      };

      stop_char = 0;
      c = getopt_long (argc, argv, "hVac:l:t:s:k:", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          gui_cmdline_parser_print_help ();
          gui_cmdline_parser_free (&local_args_info);
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
          if (local_args_info.version_given)
            {
              fprintf (stderr, "%s: `--version' (`-V') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->version_given && ! override)
            continue;
          local_args_info.version_given = 1;
          args_info->version_given = 1;
          gui_cmdline_parser_free (&local_args_info);
          return 0;

        case 'a':	/* auto-decode audio stream.  */
          if (local_args_info.auto_decode_given)
            {
              fprintf (stderr, "%s: `--auto_decode' (`-a') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->auto_decode_given && ! override)
            continue;
          local_args_info.auto_decode_given = 1;
          args_info->auto_decode_given = 1;
          args_info->auto_decode_flag = !(args_info->auto_decode_flag);
          break;

        case 'c':	/* (default='~/.paraslash/gui.conf').  */
          if (local_args_info.config_file_given)
            {
              fprintf (stderr, "%s: `--config_file' (`-c') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->config_file_given && ! override)
            continue;
          local_args_info.config_file_given = 1;
          args_info->config_file_given = 1;
          if (args_info->config_file_arg)
            free (args_info->config_file_arg); /* free previous string */
          args_info->config_file_arg = gengetopt_strdup (optarg);
          if (args_info->config_file_orig)
            free (args_info->config_file_orig); /* free previous string */
          args_info->config_file_orig = gengetopt_strdup (optarg);
          break;

        case 'l':	/* set loglevel (0-6).  */
          if (local_args_info.loglevel_given)
            {
              fprintf (stderr, "%s: `--loglevel' (`-l') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->loglevel_given && ! override)
            continue;
          local_args_info.loglevel_given = 1;
          args_info->loglevel_given = 1;
          args_info->loglevel_arg = strtol (optarg, &stop_char, 0);
          if (!(stop_char && *stop_char == '\0')) {
            fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
            goto failure;
          }
          if (args_info->loglevel_orig)
            free (args_info->loglevel_orig); /* free previous string */
          args_info->loglevel_orig = gengetopt_strdup (optarg);
          break;

        case 't':	/* set timeout.  */
          if (local_args_info.timeout_given)
            {
              fprintf (stderr, "%s: `--timeout' (`-t') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->timeout_given && ! override)
            continue;
          local_args_info.timeout_given = 1;
          args_info->timeout_given = 1;
          args_info->timeout_arg = strtol (optarg, &stop_char, 0);
          if (!(stop_char && *stop_char == '\0')) {
            fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
            goto failure;
          }
          if (args_info->timeout_orig)
            free (args_info->timeout_orig); /* free previous string */
          args_info->timeout_orig = gengetopt_strdup (optarg);
          break;

        case 's':	/* command to read server and audiod status data from.  */
          if (local_args_info.stat_cmd_given)
            {
              fprintf (stderr, "%s: `--stat_cmd' (`-s') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->stat_cmd_given && ! override)
            continue;
          local_args_info.stat_cmd_given = 1;
          args_info->stat_cmd_given = 1;
          if (args_info->stat_cmd_arg)
            free (args_info->stat_cmd_arg); /* free previous string */
          args_info->stat_cmd_arg = gengetopt_strdup (optarg);
          if (args_info->stat_cmd_orig)
            free (args_info->stat_cmd_orig); /* free previous string */
          args_info->stat_cmd_orig = gengetopt_strdup (optarg);
          break;

        case 'k':	/* Map key k to command c using mode m. Mode may be d, x or p for display, external and paraslash commands, respectively. Of course, this option may be given multiple times, one for each key mapping..  */
          local_args_info.key_map_given++;
        
          multi_token = get_multiple_arg_token(optarg);
          multi_next = get_multiple_arg_token_next (optarg);
        
          while (1)
            {
              key_map_new = (struct string_list *) malloc (sizeof (struct string_list));
              key_map_new->next = key_map_list;
              key_map_list = key_map_new;
              key_map_new->arg = gengetopt_strdup (multi_token);
              key_map_new->orig = multi_token;
        
              if (multi_next)
                {
                  multi_token = get_multiple_arg_token(multi_next);
                  multi_next = get_multiple_arg_token_next (multi_next);
                  local_args_info.key_map_given++;
                }
              else
                break;
            }
          break;


        case 0:	/* Long option with no short option */
        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          goto failure;

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c%s\n", GUI_CMDLINE_PARSER_PACKAGE, c, (additional_error ? additional_error : ""));
          abort ();
        } /* switch */
    } /* while */


  if (local_args_info.key_map_given && key_map_list)
    {
      struct string_list *tmp;
      args_info->key_map_arg = (char * *) realloc (args_info->key_map_arg, (args_info->key_map_given + local_args_info.key_map_given) * sizeof (char *));
      args_info->key_map_orig = (char **) realloc (args_info->key_map_orig, (args_info->key_map_given + local_args_info.key_map_given) * sizeof (char *));
      for (i = (local_args_info.key_map_given - 1); i >= 0; --i)
        {
          tmp = key_map_list;
          args_info->key_map_arg [i + args_info->key_map_given] = key_map_list->arg;
          args_info->key_map_orig [i + args_info->key_map_given] = key_map_list->orig;
          key_map_list = key_map_list->next;
          free (tmp);
        }
    }
  

  args_info->key_map_given += local_args_info.key_map_given;
  local_args_info.key_map_given = 0;
  
  if (check_required)
    {
      error += gui_cmdline_parser_required2 (args_info, argv[0], additional_error);
    }

  gui_cmdline_parser_release (&local_args_info);

  if ( error )
    return (EXIT_FAILURE);

  return 0;

failure:
  if (key_map_list)
    {
      struct string_list *tmp;
      while (key_map_list)
        {
          tmp = key_map_list;
          free (key_map_list->arg);
          free (key_map_list->orig);
          key_map_list = key_map_list->next;
          free (tmp);
        }
    }
  
  gui_cmdline_parser_release (&local_args_info);
  return (EXIT_FAILURE);
}

#ifndef CONFIG_FILE_LINE_SIZE
#define CONFIG_FILE_LINE_SIZE 2048
#endif
#define ADDITIONAL_ERROR " in configuration file "

#define CONFIG_FILE_LINE_BUFFER_SIZE (CONFIG_FILE_LINE_SIZE+3)
/* 3 is for "--" and "=" */

char my_argv[CONFIG_FILE_LINE_BUFFER_SIZE+1];

int
gui_cmdline_parser_configfile (char * const filename, struct gui_args_info *args_info, int override, int initialize, int check_required)
{
  FILE* file;
  char linebuf[CONFIG_FILE_LINE_SIZE];
  int line_num = 0;
  int i, result, equal;
  char *fopt, *farg;
  char *str_index;
  size_t len, next_token;
  char delimiter;
  int my_argc = 0;
  char **my_argv_arg;
  char *additional_error;

  /* store the program name */
  cmd_line_list_tmp = (struct line_list *) malloc (sizeof (struct line_list));
  cmd_line_list_tmp->next = cmd_line_list;
  cmd_line_list = cmd_line_list_tmp;
  cmd_line_list->string_arg = gengetopt_strdup (GUI_CMDLINE_PARSER_PACKAGE);

  if ((file = fopen(filename, "r")) == NULL)
    {
      fprintf (stderr, "%s: Error opening configuration file '%s'\n",
               GUI_CMDLINE_PARSER_PACKAGE, filename);
      result = EXIT_FAILURE;
      goto conf_failure;
    }

  while ((fgets(linebuf, CONFIG_FILE_LINE_SIZE, file)) != NULL)
    {
      ++line_num;
      my_argv[0] = '\0';
      len = strlen(linebuf);
      if (len > (CONFIG_FILE_LINE_BUFFER_SIZE-1))
        {
          fprintf (stderr, "%s:%s:%d: Line too long in configuration file\n",
                   GUI_CMDLINE_PARSER_PACKAGE, filename, line_num);
          result = EXIT_FAILURE;
          goto conf_failure;
        }

      /* find first non-whitespace character in the line */
      next_token = strspn ( linebuf, " \t\r\n");
      str_index  = linebuf + next_token;

      if ( str_index[0] == '\0' || str_index[0] == '#')
        continue; /* empty line or comment line is skipped */

      fopt = str_index;

      /* truncate fopt at the end of the first non-valid character */
      next_token = strcspn (fopt, " \t\r\n=");

      if (fopt[next_token] == '\0') /* the line is over */
        {
          farg  = NULL;
          equal = 0;
          goto noarg;
        }

      /* remember if equal sign is present */
      equal = (fopt[next_token] == '=');
      fopt[next_token++] = '\0';

      /* advance pointers to the next token after the end of fopt */
      next_token += strspn (fopt + next_token, " \t\r\n");
      /* check for the presence of equal sign, and if so, skip it */
      if ( !equal )
        if ((equal = (fopt[next_token] == '=')))
          {
            next_token++;
            next_token += strspn (fopt + next_token, " \t\r\n");
          }
      str_index  += next_token;

      /* find argument */
      farg = str_index;
      if ( farg[0] == '\"' || farg[0] == '\'' )
        { /* quoted argument */
          str_index = strchr (++farg, str_index[0] ); /* skip opening quote */
          if (! str_index)
            {
              fprintf
                (stderr,
                 "%s:%s:%d: unterminated string in configuration file\n",
                 GUI_CMDLINE_PARSER_PACKAGE, filename, line_num);
              result = EXIT_FAILURE;
              goto conf_failure;
            }
        }
      else
        { /* read up the remaining part up to a delimiter */
          next_token = strcspn (farg, " \t\r\n#\'\"");
          str_index += next_token;
        }

      /* truncate farg at the delimiter and store it for further check */
      delimiter = *str_index, *str_index++ = '\0';

      /* everything but comment is illegal at the end of line */
      if (delimiter != '\0' && delimiter != '#')
        {
          str_index += strspn(str_index, " \t\r\n");
          if (*str_index != '\0' && *str_index != '#')
            {
              fprintf
                (stderr,
                 "%s:%s:%d: malformed string in configuration file\n",
                 GUI_CMDLINE_PARSER_PACKAGE, filename, line_num);
              result = EXIT_FAILURE;
              goto conf_failure;
            }
        }

    noarg:
      ++my_argc;
      len = strlen(fopt);

      strcat (my_argv, len > 1 ? "--" : "-");
      strcat (my_argv, fopt);
      if (len > 1 && ((farg &&*farg) || equal))
          strcat (my_argv, "=");
      if (farg && *farg)
          strcat (my_argv, farg);

      cmd_line_list_tmp = (struct line_list *) malloc (sizeof (struct line_list));
      cmd_line_list_tmp->next = cmd_line_list;
      cmd_line_list = cmd_line_list_tmp;
      cmd_line_list->string_arg = gengetopt_strdup(my_argv);
    } /* while */

  ++my_argc; /* for program name */
  my_argv_arg = (char **) malloc((my_argc+1) * sizeof(char *));
  cmd_line_list_tmp = cmd_line_list;
  for (i = my_argc - 1; i >= 0; --i) {
    my_argv_arg[i] = cmd_line_list_tmp->string_arg;
    cmd_line_list_tmp = cmd_line_list_tmp->next;
  }
  my_argv_arg[my_argc] = 0;

  additional_error = (char *)malloc(strlen(filename) + strlen(ADDITIONAL_ERROR) + 1);
  strcpy (additional_error, ADDITIONAL_ERROR);
  strcat (additional_error, filename);
  result =
    gui_cmdline_parser_internal (my_argc, my_argv_arg, args_info, override, initialize, check_required, additional_error);

  free (additional_error);
  free (my_argv_arg);

conf_failure:
  if (file)
    fclose(file);

  free_cmd_list();
  if (result == EXIT_FAILURE)
    {
      gui_cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}
